SET GLOBAL log_bin_trust_function_creators=1; 
  

-- ----------------------------
-- Table structure for rep_eclaim_online
-- ----------------------------
DROP TABLE IF EXISTS `rep_eclaim_online`;
CREATE TABLE `rep_eclaim_online`  (
  `maininscl` varchar(3) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `tran_id` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `an` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `van_sub` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pid` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `hn` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `oi` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `charge` decimal(16, 2) NULL DEFAULT NULL,
  `fund_main` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fund_sub` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `error_code` varchar(155) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `van_link` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `hos_charge` decimal(16, 2) NULL DEFAULT NULL,
  `hmain` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `vstdate_www` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `va` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`tran_id`, `maininscl`) USING BTREE,
  INDEX `maininscl`(`maininscl`) USING BTREE,
  INDEX `tran_id`(`tran_id`) USING BTREE,
  INDEX `van_sub`(`van_sub`) USING BTREE,
  INDEX `pid`(`pid`) USING BTREE,
  INDEX `hn`(`hn`) USING BTREE,
  INDEX `oi`(`oi`) USING BTREE,
  INDEX `fund_main`(`fund_main`) USING BTREE,
  INDEX `fund_sub`(`fund_sub`) USING BTREE,
  INDEX `van_link`(`van_link`) USING BTREE,
  INDEX `error_code`(`error_code`) USING BTREE,
  INDEX `va`(`va`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of rep_eclaim_online
-- ----------------------------

-- ----------------------------
-- Table structure for rep_eclaim_online_fund
-- ----------------------------
DROP TABLE IF EXISTS `rep_eclaim_online_fund`;
CREATE TABLE `rep_eclaim_online_fund`  (
  `tran_id` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `van_link` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fund_main` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `fund_sub` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `fund_type` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `charge_claim` decimal(10, 2) NULL DEFAULT NULL,
  `charge_hos` decimal(10, 2) NULL DEFAULT NULL,
  `oi` varchar(3) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `deb_id` int(10) NULL DEFAULT NULL,
  `maininscl` char(3) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fgmain` char(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fgcode` char(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `stm_st` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'N',
  `charge_statement` decimal(10, 2) NULL DEFAULT NULL,
  `no` int(11) NULL DEFAULT NULL,
  `send_date` date NULL DEFAULT NULL,
  `send_date_www` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fund_main_st` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'N' COMMENT 'Y=กองทุนหลัก',
  `status_code` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `rep_no` char(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `err_code` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pid` varchar(13) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `hn` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `hmain` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `vstdate_www` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `va` varchar(150) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`tran_id`, `fund_main`, `fund_sub`) USING BTREE,
  INDEX `tran_id`(`tran_id`) USING BTREE,
  INDEX `van_link`(`van_link`) USING BTREE,
  INDEX `fund_main`(`fund_main`) USING BTREE,
  INDEX `fund_sub`(`fund_sub`) USING BTREE,
  INDEX `deb_id`(`deb_id`) USING BTREE,
  INDEX `maininscl`(`maininscl`) USING BTREE,
  INDEX `oi`(`oi`) USING BTREE,
  INDEX `fund_type`(`fund_type`) USING BTREE,
  INDEX `fg`(`fgmain`) USING BTREE,
  INDEX `fgcode`(`fgcode`) USING BTREE,
  INDEX `pid`(`pid`) USING BTREE,
  INDEX `hn`(`hn`) USING BTREE,
  INDEX `err_code`(`err_code`) USING BTREE,
  INDEX `va`(`va`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of rep_eclaim_online_fund
-- ----------------------------

-- ----------------------------
-- Procedure structure for sql0043_process_rep_eclaim_online_fund
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0043_process_rep_eclaim_online_fund`;
delimiter ;;
CREATE PROCEDURE `sql0043_process_rep_eclaim_online_fund`()
BEGIN



DECLARE chk TINYINT(0) DEFAULT 0; 
DECLARE tp VARCHAR(50);   
DECLARE mcl VARCHAR(10);   
DECLARE sql_var CURSOR FOR  SELECT DISTINCT
	a.tran_id ,a.maininscl
FROM
	`rep_eclaim_online` a 
LEFT JOIN rep_eclaim_online_fund b on  a.tran_id = b.tran_id
WHERE b.fund_main is null or b.fund_main='' or a.van_link<>b.van_link;
																											
DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
  
OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO tp,mcl ;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
  
SET @sql_processO := CONCAT('/* "',tp,'" */REPLACE INTO rep_eclaim_online_fund (
tran_id,
van_link,
fund_main,
fund_sub,
pid,
hn,
hmain,
vstdate_www,
err_code,
va
)
SELECT 
	cc.tran_id,
	cc.van_link ,
	cc.fund_main,  
	cc.fund_sub ,
	cc.pid ,
	cc.hn,
	cc.hmain,
  cc.vstdate_www,
	cc.error_code,
  cc.va
	FROM(
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(a.fund_sub, ",", 1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 2), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
 
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 3), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 4), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 5), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
  
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 6), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
) as cc
GROUP BY 
	cc.tran_id,
	cc.van_link ,
	cc.fund_main,  
	cc.fund_sub 
UNION ALL
SELECT 
	cc.tran_id,
	cc.van_link ,
	CASE 
	WHEN cc.maininscl ="LGO" and cc.oi="O" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="LGO" and cc.oi="I" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="SSS" and cc.oi="O" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="SSS" and cc.oi="I" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="OFC" and cc.oi="O" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="OFC" and cc.oi="I" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="UCS" and cc.oi="O" THEN "EXCEPT-UUC2"
	WHEN cc.maininscl ="UCS" and cc.oi="I" THEN "EXCEPT-UUC2"
	END as fund_main,  
		CASE 
	WHEN cc.maininscl ="LGO" and cc.oi="O" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="LGO" and cc.oi="I" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="SSS" and cc.oi="O" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="SSS" and cc.oi="I" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="OFC" and cc.oi="O" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="OFC" and cc.oi="I" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="UCS" and cc.oi="O" THEN "EXCEPT-UUC2"
	WHEN cc.maininscl ="UCS" and cc.oi="I" THEN "EXCEPT-UUC2"
	END as  fund_sub ,
	cc.pid ,
	cc.hn,
	cc.hmain,
  cc.vstdate_www,
	cc.error_code,
  cc.va
	FROM(
SELECT DISTINCT
	a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(a.fund_sub, ",", 1)
WHERE (a.error_code<>"-" and a.error_code<>"") and a.tran_id="',tp,'"
GROUP BY a.tran_id
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 2), ",", -1)
WHERE (a.error_code<>"-" and a.error_code<>"") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
 
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 3), ",", -1)
WHERE (a.error_code<>"-" and a.error_code<>"") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 4), ",", -1)
WHERE (a.error_code<>"-" and a.error_code<>"") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 5), ",", -1)
WHERE (a.error_code<>"-" and a.error_code<>"") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
  
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 6), ",", -1)
WHERE (a.error_code<>"-" and a.error_code<>"") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
) as cc
GROUP BY 
	cc.tran_id,
	cc.van_link 
	
	');
 

 
     PREPARE `execO` FROM @sql_processO;
    EXECUTE `execO`;
		 
		
SET @sql_processU := CONCAT('/* "',tp,'" */UPDATE rep_eclaim_online_fund a
INNER JOIN 	`rep_eclaim_online` b on a.tran_id = b.tran_id 
SET a.maininscl=b.maininscl ,   a.oi=b.oi 
WHERE b.tran_id = "',tp,'" ');
 
      PREPARE `execU` FROM @sql_processU;
    EXECUTE `execU`;

		END LOOP sql_command;
CLOSE sql_var;

DELETE FROM rep_eclaim_online_fund WHERE fund_sub='';

 


END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0048_process_rep_eclaim_online_fund_charge_claim_lgo_sub
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0048_process_rep_eclaim_online_fund_charge_claim_lgo_sub`;
delimiter ;;
CREATE PROCEDURE `sql0048_process_rep_eclaim_online_fund_charge_claim_lgo_sub`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0; 
DECLARE tp VARCHAR(50);   
DECLARE sql_var CURSOR FOR  SELECT DISTINCT rep_no FROM rep_statement_all_lgo;
																											
DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
  
OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO tp ;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
  
SET @sql_processO := CONCAT('/* "',tp,'" */UPDATE rep_eclaim_online_fund a
INNER JOIN (
SELECT DISTINCT
a.tran_id,
a.fgmain,
a.fgcode,
a.fund_sub,
a.fund_type,
b.charge_cost as total_claim,
REPLACE(case_drug,"-",0) as total_drug,
REPLACE(case_drug,"-",0) as dhc_drug,
CASE 	
    WHEN a.oi="O" and a.fgmain in ("OT") and b.fund_main like "%COVID%" THEN 0
		WHEN a.oi="O" and a.fgmain in ("OT") and b.fund_main not like "%COVID%" and a.fund_sub ="INSTLG" THEN REPLACE(b.case_instlg,"-",0)
		WHEN a.oi="O" and a.fgmain in ("OT") and b.fund_main not like "%COVID%" and a.fund_sub ="OTLG" THEN REPLACE(b.case_palg,"-",0)+REPLACE(b.case_otlg,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="O" and a.fgmain in ("AH") and a.fund_main in ("OTLG") and b.fund_main like "%COVID%" THEN REPLACE(b.case_palg,"-",0)+REPLACE(b.case_instlg,"-",0)+REPLACE(b.case_otlg,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="O" and a.fgmain in ("AH") and b.fund_main not like "%COVID%" THEN 0
		WHEN a.oi="O" and a.fgmain in ("OP") and REPLACE(b.case_drug,"-",0) =0  THEN REPLACE(b.case_oplg,"-",0) 
		WHEN a.oi="O" and a.fgmain in ("OP") and  REPLACE(b.case_drug,"-",0) >0   THEN REPLACE(b.case_oplg,"-",0)+REPLACE(b.case_drug,"-",0)
	 
    WHEN a.oi="I" and a.fgmain in ("OT") and b.fund_main like "%COVID%" THEN 0
		WHEN a.oi="I" and a.fgmain in ("OT") and b.fund_main not like "%COVID%" and a.fund_sub ="INSTLG" THEN REPLACE(b.case_instlg,"-",0)
		WHEN a.oi="I" and a.fgmain in ("OT") and b.fund_main not like "%COVID%" and a.fund_sub ="OTLG" THEN REPLACE(b.case_palg,"-",0)+REPLACE(b.case_otlg,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="I" and a.fgmain in ("AH") and a.fund_main in ("OTLG") and b.fund_main like "%COVID%" THEN REPLACE(b.case_palg,"-",0)+REPLACE(b.case_instlg,"-",0)+REPLACE(b.case_otlg,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="I" and a.fgmain in ("AH") and b.fund_main not like "%COVID%" THEN 0
		WHEN a.oi="I" and a.fgmain in ("IP") and REPLACE(b.case_drug,"-",0) =0  THEN REPLACE(b.case_iplg,"-",0) 
		WHEN a.oi="I" and a.fgmain in ("IP") and  REPLACE(b.case_drug,"-",0) >0   THEN REPLACE(b.case_iplg,"-",0)+REPLACE(b.case_drug,"-",0)
 
ELSE 0 end as charge_claim,
b.statement_name,
b.va,
b.error_code
 
FROM
   rep_eclaim_online_fund a
  LEFT JOIN `rep_statement_all_lgo`  b on b.tran_id=A.tran_id  
WHERE b.rep_no="',tp,'"
) as cc on cc.tran_id=a.tran_id and cc.fgmain=a.fgmain and cc.fund_sub=a.fund_sub
SET 
a.charge_claim=  IF(a.fgmain not in ("IP","OP") and CAST(cc.charge_claim as DOUBLE)>CAST(cc.total_claim as DOUBLE)  ,CAST(cc.total_claim as DOUBLE),  IF(a.fgmain in ("IP","OP"),0,CAST(cc.charge_claim as DOUBLE)) ),
a.stm_st="Y",
a.charge_statement=  IF(a.fgmain not in ("IP","OP") and CAST(cc.charge_claim as DOUBLE)>CAST(cc.total_claim as DOUBLE)  ,CAST(cc.total_claim as DOUBLE),  IF(a.fgmain in ("IP","OP"),0,CAST(cc.charge_claim as DOUBLE)) ),
a.charge_hos=  IF(a.fgmain not in ("IP","OP") and CAST(cc.charge_claim as DOUBLE) >CAST(cc.total_claim as DOUBLE) ,CAST(cc.total_claim as DOUBLE),  IF(a.fgmain in ("IP","OP"),0,CAST(cc.charge_claim as DOUBLE)) )
 ,a.send_date=IF(cc.statement_name LIKE "%APPEAL_NHSO%" ,concat(MID(cc.statement_name,32,4)-543,"-",MID(cc.statement_name,36,2),"-",MID(cc.statement_name,38,2) )  ,concat(MID(cc.statement_name,20,4)-543,"-",MID(cc.statement_name,24,2),"-",MID(cc.statement_name,26,2)) ),a.send_date_www=IF(cc.statement_name LIKE "%APPEAL_NHSO%" , MID(cc.statement_name,32,8)  ,MID(cc.statement_name,20,8) ),a.status_code=IF(cc.error_code="-" ,IF(cc.va like "%V%","V","4"),"3") ,a.rep_no="',tp,'" ,a.err_code=cc.error_code
 WHERE a.maininscl="LGO"
  ');
 

 
     PREPARE `execO` FROM @sql_processO;
    EXECUTE `execO`;
 
		END LOOP sql_command;
CLOSE sql_var;


END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0049_process_rep_eclaim_online_fund_charge_claim_lgo_main
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0049_process_rep_eclaim_online_fund_charge_claim_lgo_main`;
delimiter ;;
CREATE PROCEDURE `sql0049_process_rep_eclaim_online_fund_charge_claim_lgo_main`()
BEGIN
 
DECLARE chk TINYINT(0) DEFAULT 0; 
DECLARE tp VARCHAR(50);  
DECLARE tf VARCHAR(50);  
DECLARE ts VARCHAR(50);  
DECLARE tm VARCHAR(50);  
DECLARE th VARCHAR(50);   
DECLARE fm VARCHAR(50);   
DECLARE sql_var CURSOR FOR SELECT DISTINCT  
																	a.tran_id  , a.fund_sub,
																	CASE 
																	WHEN dd.tran_id is null THEN b.claim_cost
																	WHEN dd.tran_id is not null and (b.claim_cost-sum(IFNULL(cc.charge_sub,0)))>0 THEN b.claim_cost-sum(IFNULL(cc.charge_sub,0))
																  ELSE  0 END  as fmainST,
																	CASE WHEN dd.tran_id is null THEN b.charge_cost
																  ELSE b.charge_cost-sum(IFNULL(cc.charge_sub,0)) END  as fmain,
																	
															    CASE WHEN dd.tran_id is null THEN IFNULL(o.hos_charge,0)
																  ELSE IFNULL(IF( (o.hos_charge-sum(IFNULL(cc.charge_sub,0)))<0,0,(o.hos_charge-sum(IFNULL(cc.charge_sub,0)))),0) END as fhos, 
																	 "Y"
																 
																	FROM
																		rep_eclaim_online_fund  a
																	LEFT JOIN (
																	SELECT
																		tran_id,
																		count( fund_main ) as cn_f,
																		/*sum(charge_claim)/count( fund_main ) ,  */
																		 sum(charge_claim)  as charge_sub  ,
																		charge_hos
																	FROM
																		rep_eclaim_online_fund    
																	WHERE
																		fgmain NOT IN ( "IP", "OP" )  
																		AND maininscl = "LGO"  
																	GROUP BY tran_id , fgmain
																		) as cc on cc.tran_id=a.tran_id
																	LEFT JOIN (
																	SELECT
																		tran_id,
																		count( fund_main ) as cn_f,
																		fgmain,  
																	/*	sum(charge_claim)/count( fund_main ) */ sum(charge_claim)  as charge_sub  ,
																		charge_hos
																	
																	FROM
																		rep_eclaim_online_fund    
																	WHERE
																		fgmain  IN ( "IP", "OP" )  
																		AND maininscl = "LGO"   
																	GROUP BY tran_id , fgmain
																		) as dd on dd.tran_id=a.tran_id
																		LEFT JOIN `rep_eclaim_online` o on o.tran_id=a.tran_id 
																	LEFT JOIN (select * from `rep_statement_all_lgo` GROUP BY tran_id)   b on b.tran_id=a.tran_id 
																	
																	WHERE   
																	   a.maininscl = "LGO" and  
																		 CASE 
																					WHEN dd.tran_id is null and a.charge_claim = 0 THEN dd.tran_id is null
																					WHEN dd.tran_id is not null THEN dd.tran_id is not null
																		 ELSE a.charge_claim = 0 END AND
																		 CASE
																					WHEN dd.tran_id is null THEN TRUE
																		 ELSE a.fgmain  IN ( "IP", "OP" )  END  
																		GROUP BY a.tran_id,a.fgmain  ;
																											
DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
  
OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO tp,tf,ts, tm,th,fm ;
IF chk = 1 THEN
LEAVE sql_command;
END IF;
  
SET @sql_processO := CONCAT('/* "',tp,'" */ UPDATE
	rep_eclaim_online_fund  a
SET 
a.charge_claim ="',tm,'" ,
a.stm_st="Y",
a.charge_statement="',ts,'" ,
a.charge_hos="',th,'" , 
a.fund_main_st="',fm,'"
WHERE
	a.fund_sub ="',tf,'"
	AND a.maininscl = "LGO"  
	AND a.tran_id="',tp,'"
	 
 
  ');
 

 
     PREPARE `execO` FROM @sql_processO;
    EXECUTE `execO`;
 
		END LOOP sql_command;
CLOSE sql_var;


DELETE FROM rep_eclaim_online_fund WHERE maininscl="LGO" and fund_main is null;
DELETE FROM rep_eclaim_online_fund WHERE maininscl="LGO" and fund_main ="";
DELETE FROM rep_eclaim_online_fund WHERE maininscl="LGO" and fund_main !=""  and  charge_claim=0  and ( status_code<>"V" or fund_main_st<>"Y" ) ;
DELETE FROM rep_eclaim_online_fund WHERE maininscl="LGO" and fund_main !=""  and  status_code is null ;
DELETE FROM rep_eclaim_online_fund WHERE maininscl="LGO" and fund_main !=""  and  charge_claim is null ;


END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0050_process_rep_eclaim_online_fund_charge_claim_ofc_sub
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0050_process_rep_eclaim_online_fund_charge_claim_ofc_sub`;
delimiter ;;
CREATE PROCEDURE `sql0050_process_rep_eclaim_online_fund_charge_claim_ofc_sub`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0; 
DECLARE tp VARCHAR(50);   
DECLARE sql_var CURSOR FOR  SELECT DISTINCT rep_no FROM rep_statement_all_ofc;
																											
DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
  
OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO tp ;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
  
SET @sql_processO := CONCAT('/* "',tp,'" */UPDATE rep_eclaim_online_fund a
INNER JOIN (
SELECT DISTINCT
a.tran_id,
a.fgmain,
a.fgcode,
a.fund_sub,
a.fund_type,
b.charge_cost as total_claim,
REPLACE(case_drug,"-",0) as total_drug,
REPLACE(case_drug,"-",0) as dhc_drug,


CASE 	
    WHEN a.oi="O" and a.fgmain in ("OT") and b.fund_main like "%COVID%" THEN 0
		WHEN a.oi="O" and a.fgmain in ("OT") and b.fund_main not like "%COVID%"  and a.fund_sub ="INSTCS" THEN  REPLACE(b.case_instcs,"-",0) 
		WHEN a.oi="O" and a.fgmain in ("OT") and b.fund_main not like "%COVID%"  and a.fund_sub ="OTCS" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="O" and a.fgmain in ("AH") and a.fund_main in ("OTCS") and b.fund_main like "%COVID%" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="O" and a.fgmain in ("AH") and a.fund_main in ("OTCS") and b.fund_main not like "%COVID%" and a.fund_type like "%DM%" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="O" and a.fgmain in ("AH") and a.fund_main not in ("OTCS") and b.fund_main not like "%COVID%" and a.fund_type like "%DM%" and (REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0))>0 THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="O" and a.fgmain in ("AH") and b.fund_main not like "%COVID%" and (REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0))=0 and REPLACE(b.charge_claim,"-",0)>0  THEN REPLACE(b.charge_claim,"-",0)
		WHEN a.oi="O" and a.fgmain in ("OP") and REPLACE(b.case_drug,"-",0) =0  THEN REPLACE(b.case_opcs,"-",0) 
		WHEN a.oi="O" and a.fgmain in ("OP") and  REPLACE(b.case_drug,"-",0) >0   THEN REPLACE(b.case_opcs,"-",0)+REPLACE(b.case_drug,"-",0)
	 
    WHEN a.oi="I" and a.fgmain in ("OT") and b.fund_main like "%COVID%" THEN 0
		WHEN a.oi="I" and a.fgmain in ("OT") and b.fund_main not like "%COVID%"  and a.fund_sub ="INSTCS" THEN  REPLACE(b.case_instcs,"-",0) 
		WHEN a.oi="I" and a.fgmain in ("OT") and b.fund_main not like "%COVID%"  and a.fund_sub ="OTCS" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="I" and a.fgmain in ("AH") and a.fund_main in ("OTCS") and b.fund_main like "%COVID%" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="I" and a.fgmain in ("AH") and a.fund_main in ("OTCS") and b.fund_main not like "%COVID%" and a.fund_type like "%DM%" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="I" and a.fgmain in ("AH") and a.fund_main not in ("OTCS") and b.fund_main not like "%COVID%" and a.fund_type like "%DM%" THEN REPLACE(b.case_pacs,"-",0)+REPLACE(b.case_instcs,"-",0)+REPLACE(b.case_otcs,"-",0)+REPLACE(b.case_fpnhso,"-",0)
		WHEN a.oi="I" and a.fgmain in ("AH") and b.fund_main not like "%COVID%" THEN 0
		WHEN a.oi="I" and a.fgmain in ("IP") and REPLACE(b.case_drug,"-",0) =0  THEN REPLACE(b.case_ipcs,"-",0) 
		WHEN a.oi="I" and a.fgmain in ("IP") and  REPLACE(b.case_drug,"-",0) >0   THEN REPLACE(b.case_ipcs,"-",0)+REPLACE(b.case_drug,"-",0)
 
ELSE 0 end as charge_claim,
b.statement_name,
b.va,
b.error_code
 
FROM
   rep_eclaim_online_fund a
  LEFT JOIN `rep_statement_all_ofc`  b on b.tran_id=A.tran_id  
WHERE b.rep_no="',tp,'"
GROUP BY a.tran_id,
a.fgmain,
a.fgcode
) as cc on cc.tran_id=a.tran_id and cc.fgmain=a.fgmain and cc.fund_sub=a.fund_sub
SET 
a.charge_claim=  IF(a.fgmain not in ("IP","OP") and CAST(cc.charge_claim as DOUBLE)>CAST(cc.total_claim as DOUBLE)  ,CAST(cc.total_claim as DOUBLE),  IF(a.fgmain in ("IP","OP"),0,CAST(cc.charge_claim as DOUBLE)) ),
a.stm_st="Y",
a.charge_statement=  IF(a.fgmain not in ("IP","OP") and CAST(cc.charge_claim as DOUBLE)>CAST(cc.total_claim as DOUBLE)  ,CAST(cc.total_claim as DOUBLE),  IF(a.fgmain in ("IP","OP"),0,CAST(cc.charge_claim as DOUBLE)) ),
a.charge_hos=  IF(a.fgmain not in ("IP","OP") and CAST(cc.charge_claim as DOUBLE)>CAST(cc.total_claim as DOUBLE) ,CAST(cc.total_claim as DOUBLE),  IF(a.fgmain in ("IP","OP"),0,CAST(cc.charge_claim as DOUBLE)) )
 ,a.send_date=IF(cc.statement_name LIKE "%APPEAL_NHSO%" ,concat(MID(cc.statement_name,31,4)-543,"-",MID(cc.statement_name,35,2),"-",MID(cc.statement_name,37,2) )  ,concat(MID(cc.statement_name,19,4)-543,"-",MID(cc.statement_name,23,2),"-",MID(cc.statement_name,25,2)) ),a.send_date_www=IF(cc.statement_name LIKE "%APPEAL_NHSO%" , MID(cc.statement_name,31,8)  ,MID(cc.statement_name,19,8) ),a.status_code=IF(cc.error_code="-"  ,IF(cc.va like "%V%","V","4"),"3") ,a.rep_no="',tp,'" ,a.err_code=cc.error_code
 WHERE a.maininscl="OFC"
  ');
 

 
     PREPARE `execO` FROM @sql_processO;
    EXECUTE `execO`;
 
		END LOOP sql_command;
CLOSE sql_var;
END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0051_process_rep_eclaim_online_fund_charge_claim_ofc_main
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0051_process_rep_eclaim_online_fund_charge_claim_ofc_main`;
delimiter ;;
CREATE PROCEDURE `sql0051_process_rep_eclaim_online_fund_charge_claim_ofc_main`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0; 
DECLARE tp VARCHAR(50);  
DECLARE tf VARCHAR(50);  
DECLARE ts VARCHAR(50);  
DECLARE tm VARCHAR(50);  
DECLARE th VARCHAR(50);   
DECLARE fm VARCHAR(50);   
DECLARE sql_var CURSOR FOR SELECT DISTINCT  
																	a.tran_id  , a.fund_sub,
																	CASE 
																	WHEN dd.tran_id is null THEN b.claim_cost
																	WHEN dd.tran_id is not null and (b.claim_cost-sum(IFNULL(cc.charge_sub,0)))>0 THEN b.claim_cost-sum(IFNULL(cc.charge_sub,0))
																  ELSE  0 END  as fmainST,
																	CASE WHEN dd.tran_id is null THEN b.charge_cost
																  ELSE b.charge_cost-sum(IFNULL(cc.charge_sub,0)) END  as fmain,
																	
															    CASE WHEN dd.tran_id is null THEN IFNULL(o.hos_charge,0)
																  ELSE IFNULL(IF( (o.hos_charge-sum(IFNULL(cc.charge_sub,0)))<0,0,(o.hos_charge-sum(IFNULL(cc.charge_sub,0)))),0) END as fhos, 
																	 "Y"
																 
																	FROM
																		rep_eclaim_online_fund  a
																	LEFT JOIN (
																	SELECT
																		tran_id,
																		count( fund_main ) as cn_f,
																		/*sum(charge_claim)/count( fund_main ) ,  */
																		 sum(charge_claim)  as charge_sub  ,
																		charge_hos
																	FROM
																		rep_eclaim_online_fund    
																	WHERE
																		fgmain NOT IN ( "IP", "OP" )  
																		AND maininscl = "OFC"  
																	GROUP BY tran_id , fgmain
																		) as cc on cc.tran_id=a.tran_id
																	LEFT JOIN (
																	SELECT
																		tran_id,
																		count( fund_main ) as cn_f,
																		fgmain,  
																	/*	sum(charge_claim)/count( fund_main ) */ sum(charge_claim)  as charge_sub  ,
																		charge_hos
																	
																	FROM
																		rep_eclaim_online_fund    
																	WHERE
																		fgmain  IN ( "IP", "OP" )  
																		AND maininscl = "OFC"   
																	GROUP BY tran_id , fgmain
																		) as dd on dd.tran_id=a.tran_id
																		LEFT JOIN `rep_eclaim_online` o on o.tran_id=a.tran_id 
																	LEFT JOIN (select * from `rep_statement_all_ofc` GROUP BY tran_id)  b on b.tran_id=a.tran_id 
																	
																	WHERE   
																	   a.maininscl = "OFC" and  
																		 CASE 
																					WHEN dd.tran_id is null and a.charge_claim = 0 THEN dd.tran_id is null
																					WHEN dd.tran_id is not null THEN dd.tran_id is not null
																		 ELSE a.charge_claim = 0 END AND
																		 CASE
																					WHEN dd.tran_id is null THEN TRUE
																		 ELSE a.fgmain  IN ( "IP", "OP" )  END  
																		GROUP BY a.tran_id,a.fgmain ;
																											
DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
  
OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO tp,tf,ts, tm,th,fm ;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
  
SET @sql_processO := CONCAT('/* "',tp,'" */ UPDATE
	rep_eclaim_online_fund  a 
SET 
a.charge_claim ="',tm,'" ,
a.stm_st="Y",
a.charge_statement="',ts,'" ,
a.charge_hos="',th,'" , 
a.fund_main_st="',fm,'"
WHERE
	a.fund_sub ="',tf,'"
	AND a.maininscl = "OFC"  
	AND a.tran_id="',tp,'"
	 
 
  ');
 

 
     PREPARE `execO` FROM @sql_processO;
    EXECUTE `execO`;
 
		END LOOP sql_command;
CLOSE sql_var;

DELETE FROM rep_eclaim_online_fund WHERE maininscl="OFC" and fund_main is null;
DELETE FROM rep_eclaim_online_fund WHERE maininscl="OFC" and fund_main ="";
DELETE FROM rep_eclaim_online_fund WHERE maininscl="OFC" and fund_main !="" and  charge_claim=0 and ( status_code<>"V" or fund_main_st<>"Y" )   ;
DELETE FROM rep_eclaim_online_fund WHERE maininscl="OFC" and fund_main !="" and  status_code is null ;
DELETE FROM rep_eclaim_online_fund WHERE maininscl="OFC" and fund_main !="" and  charge_claim is null ;
END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0060_process_s_report_hosxp_web_section_tmp_s_ipd
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0060_process_s_report_hosxp_web_section_tmp_s_ipd`;
delimiter ;;
CREATE PROCEDURE `sql0060_process_s_report_hosxp_web_section_tmp_s_ipd`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0;
DECLARE causetype VARCHAR(100);
DECLARE ymdv VARCHAR(15);
DECLARE sql_var CURSOR FOR SELECT
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END AS ymd,
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN 'DATE_FORMAT(v.regdate,"%Y-%m")'
														ELSE 'v.regdate' END AS cause_type
														FROM s_report_hosxp_opitemerance_tmp_van  a,s_report_hosxp_opitemerance_pttype b 
														WHERE b.vn_an=a.vn_an
														GROUP BY CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END;
												

DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
 

OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO  ymdV, causetype;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
 


SET @sql_process := CONCAT( 'INSERT IGNORE  INTO s_report_hosxp_web_section (
guid,
hospcode,
main_hosp,
sub_hosp,
type,
vst_dc_date,
date_www_cal,
vn_an,
hn,
patient,
age_y,
pdx,
pdx_name,
pttype,
hosxp_pttype_name,
deb_type,
deb_type_approv,
deb_id,
deb_id_approv,
deb_std_code,
deb_std_code_approv,
deb_pttype,
deb_pttype_approv,
deb_name,
deb_name_approv,
income,
remain_money,
discount_money,
uc_money,
uc_money_freeze,
uc_money_freeze_new,
uc_money_freeze_approv,
paid_money,
bill_paid_in_visit,
pt_not_paid,
eclaim_date_send,
eclaim_date_send_www,
eclaim_charge_hos,
eclaim_charge_claim,
eclaim_charge_statment,
hosp,
chwpart,
error_hosp,
error_hospout_moph,
key_eclaim,
wait_to_key_eclaim,
wait_to_recieve_rep,
data_freeze_lock,
eclaim_no,
tran_id,
eclaim_status,
claim_type,
hos_more_eclaim,
eclaim_more_hos,
eclaim_more_nhso,
nhso_more_eclaim,
nhso_pay_statment,
eclaim_no_old,
status_code,
main_inscl,
sub_inscl,
rep_no,
pid,
err_code,
adjrw,
admit_date,
admit_date_www,
claim_code
) 
SELECT  
md5(concat(v.hn,v.deb_type,IFNULL(v.date_www_cal,"NonDischarg"),v.deb_id,v.an,IFNULL(f.deb_id,"K"),IFNULL(f.fund_sub,"F"))) as guid,
( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="CLIENT_ID")  as hospcode, 
IFNULL(oy.hosp_main,ov.hospmain) as main_hosp,
ov.hospsub,
"IPD" as type, 
IF(v.date_www_cal is null or v.date_www_cal="0000-00-00" ,"NonDischarg",concat(date_format(v.dchdate,"%d/%m/"),date_format(v.dchdate,"%Y")+543)) as vst_dc_date, 
IFNULL(v.date_www_cal,"NonDischarg") as date_www_cal,
v.an as vn_an,
v.hn,
v.patient,
v.age_y,
id.icd10 as pdx, 
id.dx_name as pdx_name, 
IFNULL(oy.pttype,v.pttype) as pttype, 
CONCAT(y.hosxp_pttype_name,"(",y.hosxp_pttype,")") as hosxp_pttype_name, 
m.deb_type, 
m.deb_type as deb_type_approv ,
m.id as deb_id,
m.deb_id_use as deb_id_approv,
m.deb_std_code,
m.deb_std_code_use as deb_std_code_approv,   
m.deb_pttype,
m.deb_pttype_use as deb_pttype_approv,
m.deb_name,					
m.deb_name_use as deb_name_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money+f.charge_hos+ o.discount_money ELSE f.charge_hos END ),0)  as income,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.remain_money ELSE 0 END),0) as remain_money ,
IFNULL(SUM(
CASE
WHEN   f.fund_main_st ="Y"  THEN o.discount_money ELSE 0 END),0) as  discount_money ,
 
IFNULL(SUM(
CASE
WHEN f.charge_hos >0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze ,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END ),0) as uc_money_freeze_new,
IFNULL(SUM(
CASE
WHEN f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money ELSE 0 END),0)  as paid_money,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.bill_paid_in_visit ELSE 0 END),0) as     bill_paid_in_visit,
IFNULL(SUM(
CASE
WHEN f.fund_main_st ="Y"  THEN o.pt_not_paid ELSE 0 END),0) as  pt_not_paid, 

concat(right(f.send_date_www,2),"/",mid(f.send_date_www,5,2),"/",left(f.send_date_www,4)  ) as eclaim_date_send,
f.send_date_www as eclaim_date_send_www,  

IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ),0) as eclaim_charge_hos,  

IFNULL(SUM(IFNULL(f.charge_claim,0)),0)  as  eclaim_charge_claim,

IFNULL(SUM(
CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END),0) as eclaim_charge_statment,  
 
concat(IFNULL(f.hmain,"-")," (",IFNULL(h.name,"NaN"),"-",IFNULL(h.chwname,""),")" )as hosp,
v.chwpart ,

if( v.deb_pttype="SSS-IC" and ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="SSN_MainHospitalCode" ) LIKE concat("%[",oy.pttype,"]",oy.hosp_main,"%"),"data_ready",IF(v.deb_pttype="SSS-IC","err","data_ready")) as error_hosp,
"data_ready" as error_hospout_moph , 
CASE 
WHEN  f.van_link="-"   and f.status_code in ("4") THEN   "key_in_eclaim_send_pass"
WHEN  f.van_link="-"   and f.status_code in ("3") THEN  "key_in_eclaim_send_not_pass"
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "key_in_eclaim_send_pass_wait_verify"
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN    "key_eclaim_send_pass"
WHEN  f.van_link<>"-"  and f.status_code in ("3") THEN   "key_eclaim_send_not_pass" 
WHEN  f.van_link<>"-"   and f.status_code in ("V") THEN  "key_eclaim_send_pass_wait_verify"
ELSE "-" END AS key_eclaim,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("3","V","4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("3","V","4") THEN  "N" 
ELSE "Y" END as wait_to_key_eclaim ,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("V") THEN  "N" 
ELSE "Y" END as wait_to_recieve_rep,
"N" as data_freeze_lock,
"eclaim_online" as eclaim_no,
f.tran_id,
CASE  
WHEN f.status_code in ("3") THEN  "3 = ไม่ผ่านการตรวจสอบจาก สปสช. (C)" 
WHEN f.status_code in ("4") THEN  "4 = ผ่านการตรวจสอบจาก สปสช. (A)" 
WHEN f.status_code in ("V") THEN  "V = ผ่านการตรวจสอบจาก สปสช.  แต่รอ Audit(V)" 
ELSE "-" END as status_name, 
CASE  
WHEN  f.van_link="-"   THEN  "KeyIN" 
WHEN  f.van_link<>"-"  THEN  "Import_HIS"
ELSE "KeyIN"  END as  claim_type,


IFNULL(IF( ( SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) )<0 ,  0, 
    (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) 
) ),0) as hos_more_eclaim,  


IFNULL(IF( SUM(IFNULL(f.charge_claim,0)) - (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)))<0 ,  0, 
  (SUM(IFNULL(f.charge_claim,0)) - SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0))  )
),0) as  eclaim_more_hos, 


IFNULL(IF(  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)  <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", (  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END) ) ,0)
),0) as  eclaim_more_nhso,

IFNULL(IF(  SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0)) <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", ( SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0))  ) ,0)
),0) as  nhso_more_eclaim,

CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )   THEN "Y"
ELSE f.stm_st END as nhso_pay_statment, 

"-" as eclaim_no_old,
f.status_code,
CASE WHEN m.maininscl not in ("UCS","OFC","LGO","SSS","OTH") THEN "OTH" ELSE m.maininscl END as main_inscl, 
IFNULL(m.maininscl,f.maininscl) ,
f.rep_no,
p.cid as pid,
IF(f.err_code is null or f.err_code="",f.va,f.err_code ),
ip.adjrw,
concat(DATE_FORMAT(ip.regdate,"%d/%m/"),DATE_FORMAT(ip.regdate,"%Y")+543) as admit_date,
concat((DATE_FORMAT(ip.regdate,"%Y")+543),DATE_FORMAT(ip.regdate,"%m%d")) as admit_date_www,
ov.claim_code
FROM s_report_hosxp_ipt ip 
LEFT OUTER JOIN s_report_hosxp_an_stat_all v on ip.an=v.an
LEFT JOIN s_report_hosxp_opitemerance_serviceitem_eclaim o on o.vn_an=ip.an and o.use_pttype_eclaim="Y"
LEFT JOIN s_report_hosxp_opitemerance_pttype oy on oy.vn_an=ip.an and oy.pttype=o.pttype
JOIN singhanakorn_map_deb_main_hosxp_pttype y on y.hosxp_pttype=IFNULL(oy.pttype,v.pttype)
INNER JOIN rep_eclaim_online_fund f on f.van_link=ip.an and f.status_code  in ("4","V")
LEFT OUTER JOIN singhanakorn_map_deb_main m on m.id=f.deb_id 
LEFT OUTER JOIN s_report_hosxp_web_section w on w.vn_an=oy.vn_an and w.deb_pttype_approv= m.deb_pttype_use and w.status_code in ("4","V")
LEFT JOIN s_report_hosxp_ipt_diag id on id.an=ip.an and id.diagtype="1"
LEFT OUTER JOIN sys_hospcode h on h.hospcode=f.hmain
LEFT JOIN s_report_hosxp_patient_pid p on p.hn=ip.hn 
LEFT JOIN s_report_hosxp_ovst_pttype ov on ov.vn_an=ip.an and ov.pttype=IFNULL(oy.pttype,v.pttype)
  
WHERE  ',causetype,'= "',ymdv,'"  
AND w.vn_an is null
GROUP BY ip.an,m.deb_std_code  
ORDER BY ip.an
 
 ');
 
 

    PREPARE `exec` FROM @sql_process;
    EXECUTE `exec`; 
 
 
		END LOOP sql_command;
CLOSE sql_var;
 
CALL sql0060_process_s_report_hosxp_web_section_tmp_s_ipd_c  ;


END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0060_process_s_report_hosxp_web_section_tmp_s_ipd_c
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0060_process_s_report_hosxp_web_section_tmp_s_ipd_c`;
delimiter ;;
CREATE PROCEDURE `sql0060_process_s_report_hosxp_web_section_tmp_s_ipd_c`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0;
DECLARE causetype VARCHAR(100);
DECLARE ymdv VARCHAR(15);
DECLARE sql_var CURSOR FOR SELECT
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END AS ymd,
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN 'DATE_FORMAT(v.regdate,"%Y-%m")'
														ELSE 'v.regdate' END AS cause_type
														FROM s_report_hosxp_opitemerance_tmp_van  a,s_report_hosxp_opitemerance_pttype b 
														WHERE b.vn_an=a.vn_an
														GROUP BY CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END;
												

DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
 

OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO  ymdV, causetype;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
 


SET @sql_process := CONCAT( 'INSERT IGNORE  INTO s_report_hosxp_web_section (
guid,
hospcode,
main_hosp,
sub_hosp,
type,
vst_dc_date,
date_www_cal,
vn_an,
hn,
patient,
age_y,
pdx,
pdx_name,
pttype,
hosxp_pttype_name,
deb_type,
deb_type_approv,
deb_id,
deb_id_approv,
deb_std_code,
deb_std_code_approv,
deb_pttype,
deb_pttype_approv,
deb_name,
deb_name_approv,
income,
remain_money,
discount_money,
uc_money,
uc_money_freeze,
uc_money_freeze_new,
uc_money_freeze_approv,
paid_money,
bill_paid_in_visit,
pt_not_paid,
eclaim_date_send,
eclaim_date_send_www,
eclaim_charge_hos,
eclaim_charge_claim,
eclaim_charge_statment,
hosp,
chwpart,
error_hosp,
error_hospout_moph,
key_eclaim,
wait_to_key_eclaim,
wait_to_recieve_rep,
data_freeze_lock,
eclaim_no,
tran_id,
eclaim_status,
claim_type,
hos_more_eclaim,
eclaim_more_hos,
eclaim_more_nhso,
nhso_more_eclaim,
nhso_pay_statment,
eclaim_no_old,
status_code,
main_inscl,
sub_inscl,
rep_no,
pid,
err_code,
adjrw,
admit_date,
admit_date_www,
claim_code
) 
SELECT  
md5(concat(v.hn,v.deb_type,IFNULL(v.date_www_cal,"NonDischarg"),v.deb_id,v.an,IFNULL(f.deb_id,"K"),IFNULL(f.fund_sub,"F"))) as guid,
( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="CLIENT_ID")  as hospcode, 
IFNULL(oy.hosp_main,ov.hospmain) as main_hosp,
ov.hospsub,
"IPD" as type, 
IF(v.date_www_cal is null or v.date_www_cal="0000-00-00" ,"NonDischarg",concat(date_format(v.dchdate,"%d/%m/"),date_format(v.dchdate,"%Y")+543)) as vst_dc_date, 
IFNULL(v.date_www_cal,"NonDischarg") as date_www_cal,
v.an as vn_an,
v.hn,
v.patient,
v.age_y,
id.icd10 as pdx, 
id.dx_name as pdx_name, 
IFNULL(oy.pttype,v.pttype) as pttype, 
CONCAT(y.hosxp_pttype_name,"(",y.hosxp_pttype,")") as hosxp_pttype_name, 
m.deb_type, 
m.deb_type as deb_type_approv ,
m.id as deb_id,
m.deb_id_use as deb_id_approv,
m.deb_std_code,
m.deb_std_code_use as deb_std_code_approv,   
m.deb_pttype,
m.deb_pttype_use as deb_pttype_approv,
m.deb_name,					
m.deb_name_use as deb_name_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money+f.charge_hos+ o.discount_money ELSE f.charge_hos END ),0)  as income,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.remain_money ELSE 0 END),0) as remain_money ,
IFNULL(SUM(
CASE
WHEN   f.fund_main_st ="Y"  THEN o.discount_money ELSE 0 END),0) as  discount_money ,
 
IFNULL(SUM(
CASE
WHEN f.charge_hos >0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze ,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END ),0) as uc_money_freeze_new,
IFNULL(SUM(
CASE
WHEN f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money ELSE 0 END),0)  as paid_money,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.bill_paid_in_visit ELSE 0 END),0) as     bill_paid_in_visit,
IFNULL(SUM(
CASE
WHEN f.fund_main_st ="Y"  THEN o.pt_not_paid ELSE 0 END),0) as  pt_not_paid, 

concat(right(f.send_date_www,2),"/",mid(f.send_date_www,5,2),"/",left(f.send_date_www,4)  ) as eclaim_date_send,
f.send_date_www as eclaim_date_send_www,  

IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ),0) as eclaim_charge_hos,  

IFNULL(SUM(IFNULL(f.charge_claim,0)),0)  as  eclaim_charge_claim,

IFNULL(SUM(
CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END),0) as eclaim_charge_statment,  
 
concat(IFNULL(f.hmain,"-")," (",IFNULL(h.name,"NaN"),"-",IFNULL(h.chwname,""),")" )as hosp,
v.chwpart ,

if( v.deb_pttype="SSS-IC" and ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="SSN_MainHospitalCode" ) LIKE concat("%[",oy.pttype,"]",oy.hosp_main,"%"),"data_ready",IF(v.deb_pttype="SSS-IC","err","data_ready")) as error_hosp,
"data_ready" as error_hospout_moph , 
CASE 
WHEN  f.van_link="-"   and f.status_code in ("4") THEN   "key_in_eclaim_send_pass"
WHEN  f.van_link="-"   and f.status_code in ("3") THEN  "key_in_eclaim_send_not_pass"
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "key_in_eclaim_send_pass_wait_verify"
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN    "key_eclaim_send_pass"
WHEN  f.van_link<>"-"  and f.status_code in ("3") THEN   "key_eclaim_send_not_pass" 
WHEN  f.van_link<>"-"   and f.status_code in ("V") THEN  "key_eclaim_send_pass_wait_verify"
ELSE "-" END AS key_eclaim,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("3","V","4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("3","V","4") THEN  "N" 
ELSE "Y" END as wait_to_key_eclaim ,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("V") THEN  "N" 
ELSE "Y" END as wait_to_recieve_rep,
"N" as data_freeze_lock,
"eclaim_online" as eclaim_no,
f.tran_id,
CASE  
WHEN f.status_code in ("3") THEN  "3 = ไม่ผ่านการตรวจสอบจาก สปสช. (C)" 
WHEN f.status_code in ("4") THEN  "4 = ผ่านการตรวจสอบจาก สปสช. (A)" 
WHEN f.status_code in ("V") THEN  "V = ผ่านการตรวจสอบจาก สปสช.  แต่รอ Audit(V)" 
ELSE "-" END as status_name, 
CASE  
WHEN  f.van_link="-"   THEN  "KeyIN" 
WHEN  f.van_link<>"-"  THEN  "Import_HIS"
ELSE "KeyIN"  END as  claim_type,


IFNULL(IF( ( SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) )<0 ,  0, 
    (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) 
) ),0) as hos_more_eclaim,  


IFNULL(IF( SUM(IFNULL(f.charge_claim,0)) - (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)))<0 ,  0, 
  (SUM(IFNULL(f.charge_claim,0)) - SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0))  )
),0) as  eclaim_more_hos, 


IFNULL(IF(  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)  <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", (  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END) ) ,0)
),0) as  eclaim_more_nhso,

IFNULL(IF(  SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0)) <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", ( SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0))  ) ,0)
),0) as  nhso_more_eclaim,

CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )   THEN "Y"
ELSE f.stm_st END as nhso_pay_statment, 

"-" as eclaim_no_old,
f.status_code,
CASE WHEN m.maininscl not in ("UCS","OFC","LGO","SSS","OTH") THEN "OTH" ELSE m.maininscl END as main_inscl, 
IFNULL(m.maininscl,f.maininscl) ,
f.rep_no,
p.cid as pid,
IF(f.err_code is null or f.err_code="",f.va,f.err_code ),
ip.adjrw,
concat(DATE_FORMAT(ip.regdate,"%d/%m/"),DATE_FORMAT(ip.regdate,"%Y")+543) as admit_date,
concat((DATE_FORMAT(ip.regdate,"%Y")+543),DATE_FORMAT(ip.regdate,"%m%d")) as admit_date_www,
ov.claim_code
FROM s_report_hosxp_ipt ip 
LEFT OUTER JOIN s_report_hosxp_an_stat_all v on ip.an=v.an
LEFT JOIN s_report_hosxp_opitemerance_serviceitem_eclaim o on o.vn_an=ip.an and o.use_pttype_eclaim="Y"
LEFT JOIN s_report_hosxp_opitemerance_pttype oy on oy.vn_an=ip.an and oy.pttype=o.pttype
JOIN singhanakorn_map_deb_main_hosxp_pttype y on y.hosxp_pttype=IFNULL(oy.pttype,v.pttype)
INNER JOIN rep_eclaim_online_fund f on f.van_link=ip.an and f.status_code not in ("4","V")
LEFT OUTER JOIN singhanakorn_map_deb_main m on m.id=f.deb_id 
LEFT OUTER JOIN s_report_hosxp_web_section w on w.vn_an=oy.vn_an and w.deb_pttype_approv= m.deb_pttype_use and w.status_code in ("4","V")
LEFT JOIN s_report_hosxp_ipt_diag id on id.an=ip.an and id.diagtype="1"
LEFT OUTER JOIN sys_hospcode h on h.hospcode=f.hmain
LEFT JOIN s_report_hosxp_patient_pid p on p.hn=ip.hn 
LEFT JOIN s_report_hosxp_ovst_pttype ov on ov.vn_an=ip.an and ov.pttype=IFNULL(oy.pttype,v.pttype)
  
WHERE  ',causetype,'= "',ymdv,'"  
AND w.vn_an is null
GROUP BY ip.an,m.deb_std_code  
ORDER BY ip.an
 
 ');
 
 

    PREPARE `exec` FROM @sql_process;
    EXECUTE `exec`; 
 
 
		END LOOP sql_command;
CLOSE sql_var;
 



END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0061_process_s_report_hosxp_web_section_tmp_s_opd
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0061_process_s_report_hosxp_web_section_tmp_s_opd`;
delimiter ;;
CREATE PROCEDURE `sql0061_process_s_report_hosxp_web_section_tmp_s_opd`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0;
DECLARE causetype VARCHAR(100);
DECLARE ymdv VARCHAR(15);
DECLARE sql_var CURSOR FOR SELECT
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END AS ymd,
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN 'DATE_FORMAT(v.vstdate,"%Y-%m")'
														ELSE 'v.vstdate' END AS cause_type
														FROM s_report_hosxp_opitemerance_tmp_van  a,s_report_hosxp_opitemerance_pttype b 
														WHERE b.vn_an=a.vn_an
														GROUP BY CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END;
												

DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
 
 

OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO  ymdV, causetype;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
 


SET @sql_process := CONCAT( 'INSERT IGNORE  INTO s_report_hosxp_web_section (
guid,
hospcode,
main_hosp,
sub_hosp,
type,
vst_dc_date,
date_www_cal,
vn_an,
hn,
patient,
age_y,
pdx,
pdx_name,
pttype,
hosxp_pttype_name,
deb_type,
deb_type_approv,
deb_id,
deb_id_approv,
deb_std_code,
deb_std_code_approv,
deb_pttype,
deb_pttype_approv,
deb_name,
deb_name_approv,
income,
remain_money,
discount_money,
uc_money,
uc_money_freeze,
uc_money_freeze_new,
uc_money_freeze_approv,
paid_money,
bill_paid_in_visit,
pt_not_paid,
eclaim_date_send,
eclaim_date_send_www,
eclaim_charge_hos,
eclaim_charge_claim,
eclaim_charge_statment,
hosp,
chwpart,
error_hosp,
error_hospout_moph,
key_eclaim,
wait_to_key_eclaim,
wait_to_recieve_rep,
data_freeze_lock,
eclaim_no,
tran_id,
eclaim_status,
claim_type,
hos_more_eclaim,
eclaim_more_hos,
eclaim_more_nhso,
nhso_more_eclaim,
nhso_pay_statment,

eclaim_no_old,
status_code,
main_inscl,
sub_inscl,
rep_no,
pid,
err_code,
adjrw,
admit_date,
admit_date_www,
claim_code
) 
 SELECT  
md5(concat(v.hn,v.deb_type,IFNULL(v.date_www_cal,"NonDischarg"),v.deb_id,v.vn,IFNULL(f.deb_id,"K"),IFNULL(f.fund_sub,"F"))) as guid,
( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="CLIENT_ID") as hospcode, 
IFNULL(oy.hosp_main,ov.hospmain) as main_hosp,
ov.hospsub,
"OPD" as type, 
IF(v.date_www_cal is null or v.date_www_cal="0000-00-00" ,"NonDischarg",concat(date_format(v.vstdate,"%d/%m/"),date_format(v.vstdate,"%Y")+543)) as vst_dc_date, 
IFNULL(v.date_www_cal,"NonDischarg") as date_www_cal,
v.vn as vn_an,
v.hn,
v.patient,
v.age_y,
id.icd10 as pdx, 
id.dx_name as pdx_name, 
IFNULL(oy.pttype,v.pttype) as pttype, 
CONCAT(y.hosxp_pttype_name,"(",y.hosxp_pttype,")") as hosxp_pttype_name, 
m.deb_type, 
m.deb_type as deb_type_approv ,
m.id as deb_id,
m.deb_id_use as deb_id_approv,
m.deb_std_code,
m.deb_std_code_use as deb_std_code_approv,   
m.deb_pttype,
m.deb_pttype_use as deb_pttype_approv,
m.deb_name,					
m.deb_name_use as deb_name_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money+f.charge_hos+ o.discount_money ELSE f.charge_hos END ),0)  as income,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.remain_money ELSE 0 END),0) as remain_money ,
IFNULL(SUM(
CASE
WHEN   f.fund_main_st ="Y"  THEN o.discount_money ELSE 0 END),0) as  discount_money ,
 
IFNULL(SUM(
CASE
WHEN f.charge_hos >0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze ,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END ),0) as uc_money_freeze_new,
IFNULL(SUM(
CASE
WHEN f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money ELSE 0 END),0)  as paid_money,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.bill_paid_in_visit ELSE 0 END),0) as     bill_paid_in_visit,
IFNULL(SUM(
CASE
WHEN f.fund_main_st ="Y"  THEN o.pt_not_paid ELSE 0 END),0) as  pt_not_paid, 

concat(right(f.send_date_www,2),"/",mid(f.send_date_www,5,2),"/",left(f.send_date_www,4)  ) as eclaim_date_send,
f.send_date_www as eclaim_date_send_www,  

IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ),0) as eclaim_charge_hos,  

IFNULL(SUM(IFNULL(f.charge_claim,0)),0)  as  eclaim_charge_claim,

IFNULL(SUM(
CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END),0) as eclaim_charge_statment,  


concat(IFNULL(f.hmain,"-")," (",IFNULL(h.name,"NaN"),"-",IFNULL(h.chwname,""),")" )as hosp,
v.chwpart ,

if( v.deb_pttype="SSS-IC" and ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="SSN_MainHospitalCode" ) LIKE concat("%[",oy.pttype,"]",oy.hosp_main,"%"),"data_ready",IF(v.deb_pttype="SSS-IC","err","data_ready")) as error_hosp,
"data_ready" as error_hospout_moph , 
CASE 
WHEN  f.van_link="-"   and f.status_code in ("4") THEN   "key_in_eclaim_send_pass"
WHEN  f.van_link="-"   and f.status_code in ("3") THEN  "key_in_eclaim_send_not_pass"
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "key_in_eclaim_send_pass_wait_verify"
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN    "key_eclaim_send_pass"
WHEN  f.van_link<>"-"  and f.status_code in ("3") THEN   "key_eclaim_send_not_pass" 
WHEN  f.van_link<>"-"   and f.status_code in ("V") THEN  "key_eclaim_send_pass_wait_verify"
ELSE "-" END AS key_eclaim,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("3","V","4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("3","V","4") THEN  "N" 
ELSE "Y" END as wait_to_key_eclaim ,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("V") THEN  "N" 
ELSE "Y" END as wait_to_recieve_rep,
"N" as data_freeze_lock,
"eclaim_online" as eclaim_no,
f.tran_id,
CASE  
WHEN f.status_code in ("3") THEN  "3 = ไม่ผ่านการตรวจสอบจาก สปสช. (C)" 
WHEN f.status_code in ("4") THEN  "4 = ผ่านการตรวจสอบจาก สปสช. (A)" 
WHEN f.status_code in ("V") THEN  "V = ผ่านการตรวจสอบจาก สปสช.  แต่รอ Audit(V)" 
ELSE "-" END as status_name, 
CASE  
WHEN  f.van_link="-"   THEN  "KeyIN" 
WHEN  f.van_link<>"-"  THEN  "Import_HIS"
ELSE "KeyIN"  END as  claim_type,
 
IFNULL(IF( ( SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) )<0 ,  0, 
    (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) 
) ),0) as hos_more_eclaim,  


IFNULL(IF( SUM(IFNULL(f.charge_claim,0)) - (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)))<0 ,  0, 
  (SUM(IFNULL(f.charge_claim,0)) - SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0))  )
),0) as  eclaim_more_hos, 


IFNULL(IF(  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)  <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", (  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END) ) ,0)
),0) as  eclaim_more_nhso,

IFNULL(IF(  SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0)) <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", ( SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0))  ) ,0)
),0) as  nhso_more_eclaim,

CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )   THEN "Y"
ELSE f.stm_st END as nhso_pay_statment, 

"-" as eclaim_no_old,
f.status_code,
CASE WHEN f.maininscl not in ("UCS","OFC","LGO","SSS","OTH") THEN "OTH" ELSE f.maininscl END as main_inscl, 
IFNULL(m.maininscl,f.maininscl) ,
f.rep_no,
p.cid as pid,
IF(f.err_code is null or f.err_code="",f.va,f.err_code ),
0 as adjrw,
"" as admit_date,
"" as admit_date_www,
ov.claim_code

FROM  s_report_hosxp_vn_stat_all v
LEFT JOIN s_report_hosxp_opitemerance_serviceitem_eclaim o on o.vn_an=v.vn and o.use_pttype_eclaim="Y"
LEFT JOIN s_report_hosxp_opitemerance_pttype oy on oy.vn_an=v.vn and oy.pttype=o.pttype 
LEFT JOIN singhanakorn_map_deb_main_hosxp_pttype y on y.hosxp_pttype=IFNULL(oy.pttype,v.pttype) 
INNER JOIN rep_eclaim_online_fund f on f.van_link=v.vn and f.status_code in ("4","V")
LEFT OUTER JOIN singhanakorn_map_deb_main m on m.id=f.deb_id 
LEFT OUTER JOIN s_report_hosxp_web_section w on w.vn_an=oy.vn_an and w.deb_pttype_approv= m.deb_pttype_use and w.status_code in ("4","V")
LEFT JOIN s_report_hosxp_ovst_diag id on id.vn=v.vn and id.diagtype="1"
LEFT OUTER JOIN sys_hospcode h on h.hospcode=f.hmain
LEFT JOIN s_report_hosxp_patient_pid p on p.hn=v.hn 
LEFT JOIN s_report_hosxp_ovst_pttype ov on ov.vn_an=v.vn and ov.pttype=IFNULL(oy.pttype,v.pttype)
 
WHERE  ',causetype,'= "',ymdv,'"  
AND w.vn_an is null
GROUP BY v.vn,m.deb_std_code  
ORDER BY v.vn 
 
 ');
 
 

    PREPARE `exec` FROM @sql_process;
    EXECUTE `exec`; 
 
 
		END LOOP sql_command;
CLOSE sql_var;
 

CALL sql0061_process_s_report_hosxp_web_section_tmp_s_opd_c  ;

END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0061_process_s_report_hosxp_web_section_tmp_s_opd_c
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0061_process_s_report_hosxp_web_section_tmp_s_opd_c`;
delimiter ;;
CREATE PROCEDURE `sql0061_process_s_report_hosxp_web_section_tmp_s_opd_c`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0;
DECLARE causetype VARCHAR(100);
DECLARE ymdv VARCHAR(15);
DECLARE sql_var CURSOR FOR SELECT
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END AS ymd,
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN 'DATE_FORMAT(v.vstdate,"%Y-%m")'
														ELSE 'v.vstdate' END AS cause_type
														FROM s_report_hosxp_opitemerance_tmp_van  a,s_report_hosxp_opitemerance_pttype b 
														WHERE b.vn_an=a.vn_an
														GROUP BY CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END;
												

DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
 
 

OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO  ymdV, causetype;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
 


SET @sql_process := CONCAT( 'INSERT IGNORE  INTO s_report_hosxp_web_section (
guid,
hospcode,
main_hosp,
sub_hosp,
type,
vst_dc_date,
date_www_cal,
vn_an,
hn,
patient,
age_y,
pdx,
pdx_name,
pttype,
hosxp_pttype_name,
deb_type,
deb_type_approv,
deb_id,
deb_id_approv,
deb_std_code,
deb_std_code_approv,
deb_pttype,
deb_pttype_approv,
deb_name,
deb_name_approv,
income,
remain_money,
discount_money,
uc_money,
uc_money_freeze,
uc_money_freeze_new,
uc_money_freeze_approv,
paid_money,
bill_paid_in_visit,
pt_not_paid,
eclaim_date_send,
eclaim_date_send_www,
eclaim_charge_hos,
eclaim_charge_claim,
eclaim_charge_statment,
hosp,
chwpart,
error_hosp,
error_hospout_moph,
key_eclaim,
wait_to_key_eclaim,
wait_to_recieve_rep,
data_freeze_lock,
eclaim_no,
tran_id,
eclaim_status,
claim_type,
hos_more_eclaim,
eclaim_more_hos,
eclaim_more_nhso,
nhso_more_eclaim,
nhso_pay_statment,

eclaim_no_old,
status_code,
main_inscl,
sub_inscl,
rep_no,
pid,
err_code,
adjrw,
admit_date,
admit_date_www,
claim_code
) 
 SELECT  
md5(concat(v.hn,v.deb_type,IFNULL(v.date_www_cal,"NonDischarg"),v.deb_id,v.vn,IFNULL(f.deb_id,"K"),IFNULL(f.fund_sub,"F"))) as guid,
( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="CLIENT_ID") as hospcode, 
IFNULL(oy.hosp_main,ov.hospmain) as main_hosp,
ov.hospsub,
"OPD" as type, 
IF(v.date_www_cal is null or v.date_www_cal="0000-00-00" ,"NonDischarg",concat(date_format(v.vstdate,"%d/%m/"),date_format(v.vstdate,"%Y")+543)) as vst_dc_date, 
IFNULL(v.date_www_cal,"NonDischarg") as date_www_cal,
v.vn as vn_an,
v.hn,
v.patient,
v.age_y,
id.icd10 as pdx, 
id.dx_name as pdx_name, 
IFNULL(oy.pttype,v.pttype) as pttype, 
CONCAT(y.hosxp_pttype_name,"(",y.hosxp_pttype,")") as hosxp_pttype_name, 
m.deb_type, 
m.deb_type as deb_type_approv ,
m.id as deb_id,
m.deb_id_use as deb_id_approv,
m.deb_std_code,
m.deb_std_code_use as deb_std_code_approv,   
m.deb_pttype,
m.deb_pttype_use as deb_pttype_approv,
m.deb_name,					
m.deb_name_use as deb_name_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money+f.charge_hos+ o.discount_money ELSE f.charge_hos END ),0)  as income,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.remain_money ELSE 0 END),0) as remain_money ,
IFNULL(SUM(
CASE
WHEN   f.fund_main_st ="Y"  THEN o.discount_money ELSE 0 END),0) as  discount_money ,
 
IFNULL(SUM(
CASE
WHEN f.charge_hos >0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze ,
IFNULL(SUM(
CASE
WHEN  f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END ),0) as uc_money_freeze_new,
IFNULL(SUM(
CASE
WHEN f.charge_hos>0  THEN f.charge_hos
ELSE o.uc_money  END),0) as uc_money_freeze_approv ,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"   THEN o.paid_money ELSE 0 END),0)  as paid_money,
IFNULL(SUM(
CASE
WHEN  f.fund_main_st ="Y"  THEN o.bill_paid_in_visit ELSE 0 END),0) as     bill_paid_in_visit,
IFNULL(SUM(
CASE
WHEN f.fund_main_st ="Y"  THEN o.pt_not_paid ELSE 0 END),0) as  pt_not_paid, 

concat(right(f.send_date_www,2),"/",mid(f.send_date_www,5,2),"/",left(f.send_date_www,4)  ) as eclaim_date_send,
f.send_date_www as eclaim_date_send_www,  

IFNULL(SUM(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ),0) as eclaim_charge_hos,  

IFNULL(SUM(IFNULL(f.charge_claim,0)),0)  as  eclaim_charge_claim,

IFNULL(SUM(
CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END),0) as eclaim_charge_statment,  


concat(IFNULL(f.hmain,"-")," (",IFNULL(h.name,"NaN"),"-",IFNULL(h.chwname,""),")" )as hosp,
v.chwpart ,

if( v.deb_pttype="SSS-IC" and ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="SSN_MainHospitalCode" ) LIKE concat("%[",oy.pttype,"]",oy.hosp_main,"%"),"data_ready",IF(v.deb_pttype="SSS-IC","err","data_ready")) as error_hosp,
"data_ready" as error_hospout_moph , 
CASE 
WHEN  f.van_link="-"   and f.status_code in ("4") THEN   "key_in_eclaim_send_pass"
WHEN  f.van_link="-"   and f.status_code in ("3") THEN  "key_in_eclaim_send_not_pass"
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "key_in_eclaim_send_pass_wait_verify"
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN    "key_eclaim_send_pass"
WHEN  f.van_link<>"-"  and f.status_code in ("3") THEN   "key_eclaim_send_not_pass" 
WHEN  f.van_link<>"-"   and f.status_code in ("V") THEN  "key_eclaim_send_pass_wait_verify"
ELSE "-" END AS key_eclaim,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("3","V","4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("3","V","4") THEN  "N" 
ELSE "Y" END as wait_to_key_eclaim ,
CASE  
WHEN  f.van_link="-"   and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("4") THEN  "N" 
WHEN  f.van_link="-"   and f.status_code in ("V") THEN  "N" 
WHEN  f.van_link<>"-"  and f.status_code in ("V") THEN  "N" 
ELSE "Y" END as wait_to_recieve_rep,
"N" as data_freeze_lock,
"eclaim_online" as eclaim_no,
f.tran_id,
CASE  
WHEN f.status_code in ("3") THEN  "3 = ไม่ผ่านการตรวจสอบจาก สปสช. (C)" 
WHEN f.status_code in ("4") THEN  "4 = ผ่านการตรวจสอบจาก สปสช. (A)" 
WHEN f.status_code in ("V") THEN  "V = ผ่านการตรวจสอบจาก สปสช.  แต่รอ Audit(V)" 
ELSE "-" END as status_name, 
CASE  
WHEN  f.van_link="-"   THEN  "KeyIN" 
WHEN  f.van_link<>"-"  THEN  "Import_HIS"
ELSE "KeyIN"  END as  claim_type,
 
IFNULL(IF( ( SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) )<0 ,  0, 
    (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)) - SUM(IFNULL(f.charge_claim,0)) 
) ),0) as hos_more_eclaim,  


IFNULL(IF( SUM(IFNULL(f.charge_claim,0)) - (SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0)))<0 ,  0, 
  (SUM(IFNULL(f.charge_claim,0)) - SUM(IFNULL(
CASE
WHEN  f.charge_hos>0 THEN f.charge_hos
ELSE  o.uc_money  END ,0))  )
),0) as  eclaim_more_hos, 


IFNULL(IF(  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)  <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", (  SUM(IFNULL(f.charge_claim,0)) - SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END) ) ,0)
),0) as  eclaim_more_nhso,

IFNULL(IF(  SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0)) <0 and f.stm_st="Y" ,0,
 IF( f.stm_st="Y", ( SUM(CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )  THEN IFNULL(f.charge_claim,0)
ELSE IFNULL(f.charge_statement,0) END)-SUM(IFNULL(f.charge_claim,0))  ) ,0)
),0) as  nhso_more_eclaim,

CASE WHEN f.maininscl in ("SSS") and (   f.err_code="-" or  f.err_code is null or f.err_code="" )   THEN "Y"
ELSE f.stm_st END as nhso_pay_statment, 

"-" as eclaim_no_old,
f.status_code,
CASE WHEN f.maininscl not in ("UCS","OFC","LGO","SSS","OTH") THEN "OTH" ELSE f.maininscl END as main_inscl, 
IFNULL(m.maininscl,f.maininscl) ,
f.rep_no,
p.cid as pid,
IF(f.err_code is null or f.err_code="",f.va,f.err_code ),
0 as adjrw,
"" as admit_date,
"" as admit_date_www,
ov.claim_code

FROM  s_report_hosxp_vn_stat_all v
LEFT JOIN s_report_hosxp_opitemerance_serviceitem_eclaim o on o.vn_an=v.vn and o.use_pttype_eclaim="Y"
LEFT JOIN s_report_hosxp_opitemerance_pttype oy on oy.vn_an=v.vn and oy.pttype=o.pttype 
LEFT JOIN singhanakorn_map_deb_main_hosxp_pttype y on y.hosxp_pttype=IFNULL(oy.pttype,v.pttype) 
INNER JOIN rep_eclaim_online_fund f on f.van_link=v.vn and f.status_code not in ("4","V")
LEFT OUTER JOIN singhanakorn_map_deb_main m on m.id=f.deb_id 
LEFT OUTER JOIN s_report_hosxp_web_section w on w.vn_an=oy.vn_an and w.deb_pttype_approv= m.deb_pttype_use and w.status_code in ("4","V")
LEFT JOIN s_report_hosxp_ovst_diag id on id.vn=v.vn and id.diagtype="1"
LEFT OUTER JOIN sys_hospcode h on h.hospcode=f.hmain
LEFT JOIN s_report_hosxp_patient_pid p on p.hn=v.hn 
LEFT JOIN s_report_hosxp_ovst_pttype ov on ov.vn_an=v.vn and ov.pttype=IFNULL(oy.pttype,v.pttype)
 
WHERE  ',causetype,'= "',ymdv,'"  
AND w.vn_an is null
GROUP BY v.vn,m.deb_std_code  
ORDER BY v.vn 
 
 ');
 
 

    PREPARE `exec` FROM @sql_process;
    EXECUTE `exec`; 
 
 
		END LOOP sql_command;
CLOSE sql_var;
 



END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0062_process_s_report_hosxp_web_section_tmp_w_ipd_other
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0062_process_s_report_hosxp_web_section_tmp_w_ipd_other`;
delimiter ;;
CREATE PROCEDURE `sql0062_process_s_report_hosxp_web_section_tmp_w_ipd_other`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0;
DECLARE causetype VARCHAR(100);
DECLARE ymdv VARCHAR(15);
DECLARE sql_var CURSOR FOR SELECT
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END AS ymd,
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN 'DATE_FORMAT(v.regdate,"%Y-%m")'
														ELSE 'v.regdate' END AS cause_type
														FROM s_report_hosxp_opitemerance_tmp_van  a,s_report_hosxp_opitemerance_pttype b 
														WHERE b.vn_an=a.vn_an
														GROUP BY CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END;
												

DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;


OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO  ymdV, causetype;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
 


SET @sql_process := CONCAT( 'INSERT IGNORE  INTO s_report_hosxp_web_section (
guid,
hospcode,
main_hosp,
sub_hosp,
type,
vst_dc_date,
date_www_cal,
vn_an,
hn,
patient,
age_y,
pdx,
pdx_name,
pttype,
hosxp_pttype_name,
deb_type,
deb_type_approv,
deb_id,
deb_id_approv,
deb_std_code,
deb_std_code_approv,
deb_pttype,
deb_pttype_approv,
deb_name,
deb_name_approv,
income,
remain_money,
discount_money,
uc_money,
uc_money_freeze,
uc_money_freeze_new,
uc_money_freeze_approv,
paid_money,
bill_paid_in_visit,
pt_not_paid,
eclaim_date_send,
eclaim_date_send_www,
eclaim_charge_hos,
eclaim_charge_claim,
eclaim_charge_statment,
hosp,
chwpart,
error_hosp,
error_hospout_moph,
key_eclaim,
wait_to_key_eclaim,
wait_to_recieve_rep,
data_freeze_lock,
eclaim_no,
tran_id,
eclaim_status,
claim_type,
hos_more_eclaim,
eclaim_more_hos,
eclaim_more_nhso,
nhso_more_eclaim,
nhso_pay_statment,
nhso_tranfer_status,
nhso_tranfer_status_money,
eclaim_no_old,
status_code,
main_inscl,
sub_inscl,
rep_no,
pid,
err_code,
adjrw,
admit_date,
admit_date_www,
claim_code
) 
SELECT  
md5(concat(v.hn,"IPD",IFNULL(v.date_www_cal,"NonDischarg"),m.id,v.an,IFNULL(m.id,"K"),IFNULL("-","F"))) as guid,
( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="CLIENT_ID")  as hospcode, 
IFNULL(oy.hosp_main,ov.hospmain) as main_hosp,
ov.hospsub,
"IPD" as type, 
IF(v.date_www_cal is null or v.date_www_cal="0000-00-00" ,"NonDischarg",concat(date_format(v.dchdate,"%d/%m/"),date_format(v.dchdate,"%Y")+543)) as vst_dc_date, 
IFNULL(v.date_www_cal,"NonDischarg") as date_www_cal,
v.an as vn_an,
v.hn,
IFNULL(v.patient,concat(p.pname,p.fname," ",p.lname)) as patient,
v.age_y,
id.icd10 as pdx, 
id.dx_name as pdx_name, 
IFNULL(oy.pttype,v.pttype) as pttype, 
CONCAT(y.hosxp_pttype_name,"(",y.hosxp_pttype,")") as hosxp_pttype_name, 
m.deb_type, 
m.deb_type as deb_type_approv ,
m.id as deb_id,
m.deb_id_use as deb_id_approv,
m.deb_std_code,
m.deb_std_code_use as deb_std_code_approv,   
m.deb_pttype,
m.deb_pttype_use as deb_pttype_approv,
m.deb_name,					
m.deb_name_use as deb_name_approv ,
IFNULL(SUM( o.income ),0)  as income,  
IFNULL(SUM( o.remain_money) ,0) as remain_money ,
IFNULL(SUM( o.discount_money ),0) as  discount_money ,
 
IFNULL(SUM( o.uc_money ) ,0) as uc_money,
IFNULL(SUM( o.uc_money ),0) as uc_money_freeze ,
IFNULL(SUM( o.uc_money ),0) as uc_money_freeze_new,
IFNULL(SUM( o.uc_money ),0) as uc_money_freeze_approv ,
IFNULL(SUM( o.paid_money ),0)  as paid_money,
IFNULL(SUM( o.bill_paid_in_visit ),0) as  bill_paid_in_visit,
IFNULL(SUM( o.pt_not_paid) ,0) as  pt_not_paid,  

"" as eclaim_date_send,
"" as eclaim_date_send_www,  

IFNULL(SUM( o.uc_money ),0) as eclaim_charge_hos,  

0  as  eclaim_charge_claim,

0 as eclaim_charge_statment,  

concat(IFNULL(IFNULL(oy.hosp_main,v.hosp),"-")," (",IFNULL(h.name,"NaN"),"-",IFNULL(h.chwname,""),")" )as hosp,
v.chwpart ,

if( v.deb_pttype="SSS-IC" and ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="SSN_MainHospitalCode" ) LIKE concat("%[",oy.pttype,"]",oy.hosp_main,"%"),"data_ready",IF(v.deb_pttype="SSS-IC","err","data_ready")) as error_hosp,
"data_ready" as error_hospout_moph , 

CASE 
WHEN   w.vn_an IS NULL AND (m.eclaim="Y" or y.eclaim_ipd="Y")  THEN   "wait_to_key_eclaim"
ELSE "-" END AS key_eclaim,
CASE 
WHEN   w.vn_an IS NULL AND (m.eclaim="Y" or y.eclaim_ipd="Y")  THEN   "Y"
WHEN   w.vn_an IS NULL AND m.eclaim="N"    THEN   "-"
ELSE "-" END AS wait_to_key_eclaim,
 
"N"  as wait_to_recieve_rep,
"N" as data_freeze_lock,
"-" as eclaim_no,
"-" as tran_id,
 "-" as status_name, 
 "-" as  claim_type,
 
0 as hos_more_eclaim,  
0 as  eclaim_more_hos, 
0 as  eclaim_more_nhso,
0 as  nhso_more_eclaim,

"" as nhso_pay_statment, 
NULL as nhso_tranfer_status,  
NULL as nhso_tranfer_status_money,
"-" as eclaim_no_old,
NULL as status_code, 
CASE WHEN m.maininscl not in ("UCS","OFC","LGO","SSS","OTH") THEN "OTH" ELSE m.maininscl END as main_inscl, 
IFNULL(m.maininscl,m.maininscl_main) ,
"" as rep_no,
p.cid as pid,
"-" as err_code,
ip.adjrw,
concat(DATE_FORMAT(ip.regdate,"%d/%m/"),DATE_FORMAT(ip.regdate,"%Y")+543) as admit_date,
concat((DATE_FORMAT(ip.regdate,"%Y")+543),DATE_FORMAT(ip.regdate,"%m%d")) as admit_date_www,
ov.claim_code 
FROM s_report_hosxp_ipt ip 
LEFT OUTER JOIN s_report_hosxp_an_stat_all v on ip.an=v.an
LEFT JOIN s_report_hosxp_opitemerance_serviceitem_eclaim o on o.vn_an=ip.an 
LEFT JOIN s_report_hosxp_opitemerance_pttype oy on oy.vn_an=ip.an and oy.pttype=o.pttype  
JOIN singhanakorn_map_deb_main_hosxp_pttype y on y.hosxp_pttype=IFNULL(oy.pttype,v.pttype)
LEFT OUTER JOIN singhanakorn_map_deb_main m on m.deb_pttype=y.deb_pttype and m.deb_type="IPD"
LEFT OUTER JOIN s_report_hosxp_web_section w on w.vn_an=oy.vn_an and ((w.deb_pttype_approv= m.deb_pttype_use) or ((w.deb_pttype_approv<>m.deb_pttype_use) and w.pttype=o.pttype and w.uc_money=o.uc_money ))
LEFT JOIN s_report_hosxp_ipt_diag id on id.an=ip.an and id.diagtype="1"
LEFT OUTER JOIN sys_hospcode h on h.hospcode=IFNULL(oy.hosp_main,v.hosp)
LEFT JOIN s_report_hosxp_patient_pid p on p.hn=ip.hn 
LEFT JOIN s_report_hosxp_ovst_pttype ov on ov.vn_an=ip.an and ov.pttype=IFNULL(oy.pttype,v.pttype)
  
WHERE   ',causetype,'= "',ymdv,'"  
AND w.vn_an is null
and  o.income  > 0
GROUP BY ip.an,m.deb_std_code_use  
ORDER BY ip.an
 
 
 ');
 
 

    PREPARE `exec` FROM @sql_process;
    EXECUTE `exec`; 
 
 
		END LOOP sql_command;
CLOSE sql_var;
 



END
;;
delimiter ;

-- ----------------------------
-- Procedure structure for sql0063_process_s_report_hosxp_web_section_tmp_w_opd_other
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0063_process_s_report_hosxp_web_section_tmp_w_opd_other`;
delimiter ;;
CREATE PROCEDURE `sql0063_process_s_report_hosxp_web_section_tmp_w_opd_other`()
BEGIN

DECLARE chk TINYINT(0) DEFAULT 0;
DECLARE causetype VARCHAR(100);
DECLARE ymdv VARCHAR(15);
DECLARE sql_var CURSOR FOR SELECT
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END AS ymd,
														CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN 'DATE_FORMAT(v.vstdate,"%Y-%m")'
														ELSE 'v.vstdate' END AS cause_type
														FROM s_report_hosxp_opitemerance_tmp_van  a,s_report_hosxp_opitemerance_pttype b 
														WHERE b.vn_an=a.vn_an
														GROUP BY CASE
														WHEN ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name='DATA_DAY_PER_ROUND')='N' THEN a.ym
														ELSE a.vstdate END;
												

DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
 
 

OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO  ymdV, causetype;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
 


SET @sql_process := CONCAT( 'INSERT IGNORE  INTO s_report_hosxp_web_section (
guid,
hospcode,
main_hosp,
sub_hosp,
type,
vst_dc_date,
date_www_cal,
vn_an,
hn,
patient,
age_y,
pdx,
pdx_name,
pttype,
hosxp_pttype_name,
deb_type,
deb_type_approv,
deb_id,
deb_id_approv,
deb_std_code,
deb_std_code_approv,
deb_pttype,
deb_pttype_approv,
deb_name,
deb_name_approv,
income,
remain_money,
discount_money,
uc_money,
uc_money_freeze,
uc_money_freeze_new,
uc_money_freeze_approv,
paid_money,
bill_paid_in_visit,
pt_not_paid,
eclaim_date_send,
eclaim_date_send_www,
eclaim_charge_hos,
eclaim_charge_claim,
eclaim_charge_statment,
hosp,
chwpart,
error_hosp,
error_hospout_moph,
key_eclaim,
wait_to_key_eclaim,
wait_to_recieve_rep,
data_freeze_lock,
eclaim_no,
tran_id,
eclaim_status,
claim_type,
hos_more_eclaim,
eclaim_more_hos,
eclaim_more_nhso,
nhso_more_eclaim,
nhso_pay_statment,
nhso_tranfer_status,
nhso_tranfer_status_money,
eclaim_no_old,
status_code,
main_inscl,
sub_inscl,
rep_no,
pid,
err_code,
adjrw,
admit_date,
admit_date_www,
claim_code
) SELECT  
md5(concat(v.hn,"OPD",IFNULL(v.date_www_cal,"NonDischarg"),m.id,v.vn,IFNULL(m.id,"K"),IFNULL("-","F"))) as guid,
( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="CLIENT_ID") as hospcode, 
IFNULL(oy.hosp_main,ov.hospmain) as main_hosp,
ov.hospsub,
"OPD" as type, 
IF(v.date_www_cal is null or v.date_www_cal="0000-00-00" ,"NonDischarg",concat(date_format(v.vstdate,"%d/%m/"),date_format(v.vstdate,"%Y")+543)) as vst_dc_date, 
IFNULL(v.date_www_cal,"NonDischarg") as date_www_cal,
v.vn as vn_an,
v.hn,
IFNULL(v.patient,concat(p.pname,p.fname," ",p.lname)) as patient,
v.age_y,
id.icd10 as pdx, 
id.dx_name as pdx_name, 
IFNULL(oy.pttype,v.pttype) as pttype,  
CONCAT(y.hosxp_pttype_name,"(",y.hosxp_pttype,")") as hosxp_pttype_name, 
m.deb_type, 
m.deb_type as deb_type_approv ,
m.id as deb_id,
m.deb_id_use as deb_id_approv,
m.deb_std_code,
m.deb_std_code_use as deb_std_code_approv,   
m.deb_pttype,
m.deb_pttype_use as deb_pttype_approv,
m.deb_name,					
m.deb_name_use as deb_name_approv ,
IFNULL(SUM( o.income ),0)  as income,  
IFNULL(SUM( o.remain_money) ,0) as remain_money ,
IFNULL(SUM( o.discount_money ),0) as  discount_money ,
 
IFNULL(SUM( o.uc_money ) ,0) as uc_money,
IFNULL(SUM( o.uc_money ),0) as uc_money_freeze ,
IFNULL(SUM( o.uc_money ),0) as uc_money_freeze_new,
IFNULL(SUM( o.uc_money ),0) as uc_money_freeze_approv ,
IFNULL(SUM( o.paid_money ),0)  as paid_money,
IFNULL(SUM( o.bill_paid_in_visit ),0) as  bill_paid_in_visit,
IFNULL(SUM( o.pt_not_paid) ,0) as  pt_not_paid,  

"" as eclaim_date_send,
"" as eclaim_date_send_www,  

IFNULL(SUM( o.uc_money ),0) as eclaim_charge_hos,  

0  as  eclaim_charge_claim,

0 as eclaim_charge_statment,  

concat(IFNULL(IFNULL(oy.hosp_main,v.hosp),"-")," (",IFNULL(h.name,"NaN"),"-",IFNULL(h.chwname,""),")" )as hosp,
v.chwpart ,

if( v.deb_pttype="SSS-IC" and ( SELECT  sys_values FROM sys_ehos_setting WHERE sys_name="SSN_MainHospitalCode" ) LIKE concat("%[",oy.pttype,"]",oy.hosp_main,"%"),"data_ready",IF(v.deb_pttype="SSS-IC","err","data_ready")) as error_hosp,
"data_ready" as error_hospout_moph ,

CASE
WHEN   w.vn_an IS NULL AND (m.eclaim="Y" or y.eclaim_opd="Y")  THEN   "wait_to_key_eclaim" 
ELSE "-" END AS key_eclaim,
CASE
WHEN   w.vn_an IS NULL AND (m.eclaim="Y" or y.eclaim_opd="Y")  THEN   "Y" 
WHEN   w.vn_an IS NULL AND m.eclaim="N"    THEN   "-"
ELSE "-" END AS wait_to_key_eclaim,
 
"N"  as wait_to_recieve_rep,
"N" as data_freeze_lock,
"-" as eclaim_no,
"-" as tran_id,
 "-" as status_name, 
 "-" as  claim_type,
 
0 as hos_more_eclaim,  
0 as  eclaim_more_hos, 
0 as  eclaim_more_nhso,
0 as  nhso_more_eclaim,

"" as nhso_pay_statment, 
NULL as nhso_tranfer_status,  
NULL as nhso_tranfer_status_money,
"-" as eclaim_no_old,
NULL as status_code,
CASE WHEN m.maininscl not in ("UCS","OFC","LGO","SSS","OTH") THEN "OTH" ELSE m.maininscl END as main_inscl, 
IFNULL(m.maininscl,m.maininscl_main) ,
"" as rep_no,
p.cid as pid,
"-" as err_code,
"" as adjrw,
"" as admit_date,
"" as admit_date_www,
ov.claim_code
FROM  s_report_hosxp_vn_stat_all v
LEFT JOIN s_report_hosxp_opitemerance_serviceitem_eclaim o on o.vn_an=v.vn
LEFT JOIN s_report_hosxp_opitemerance_pttype oy on oy.vn_an=v.vn and oy.pttype=o.pttype  
LEFT JOIN s_report_hosxp_ovst_diag id on id.vn=v.vn and id.diagtype="1"
LEFT JOIN singhanakorn_map_deb_main_hosxp_pttype y on y.hosxp_pttype=IFNULL(oy.pttype,v.pttype)
LEFT OUTER JOIN singhanakorn_map_deb_main m on m.deb_pttype=y.deb_pttype and m.deb_type="OPD"
LEFT OUTER JOIN( SELECT max(no) as fno,REPLACE(van_link,"EX","") as van_link FROM rep_eclaim_online_fund WHERE maininscl="UCS" and van_link<>"-" GROUP BY van_link) el on el.van_link=v.vn  
LEFT OUTER JOIN s_report_hosxp_web_section w on w.vn_an=oy.vn_an and w.pttype=oy.pttype 
      and CASE WHEN m.maininscl_main="UCS" and el.van_link is not null and el.fno=1 THEN TRUE 
			         WHEN m.maininscl_main="UCS" and  el.van_link is not null and el.fno>1 THEN ((w.deb_id_approv=m.deb_id_use) or (w.deb_id_approv ="112") )
			         WHEN  w.pdx=id.icd10 and w.uc_money=o.uc_money and w.wait_to_key_eclaim in ("Y","N") THEN TRUE
							ELSE  ((w.deb_id_approv=m.deb_id_use) or (w.deb_id_approv ="112") )  END

LEFT OUTER JOIN sys_hospcode h on h.hospcode=IFNULL(oy.hosp_main,v.hosp)
LEFT JOIN s_report_hosxp_patient_pid p on p.hn=v.hn 
LEFT JOIN s_report_hosxp_ovst_pttype ov on ov.vn_an=v.vn and ov.pttype=IFNULL(oy.pttype,v.pttype)
 
WHERE  ',causetype,'= "',ymdv,'"  
AND w.vn_an is null
and  o.income  > 0
GROUP BY v.vn,m.deb_std_code_use  
ORDER BY v.vn 
 
 ');
 
 

    PREPARE `exec` FROM @sql_process;
    EXECUTE `exec`; 
 
 
		END LOOP sql_command;
CLOSE sql_var;

 /* CLEAR Duplicate DATA 	 */
/* DELETE 
FROM
	 `s_report_hosxp_web_section` 
WHERE
	`guid` = '' 
	OR guid IS NULL;
*/

END
;;
delimiter ;


INSERT IGNORE INTO `s_rep_project_eclaim_subfund` (`fund_type`, `fgcode`, `fcode`, `fundsub`, `subfund`, `gyear`, `start_date`, `end_date`, `deb_id_opd`, `deb_id_ipd`, `maininscl`, `fundmain`, `except_subfund`, `except_subfund_detail`, `hmain_subfund`, `hmain_subfund_detail`, `fgmain`, `extract_fund`) VALUES ('DM', 'DMIS', 'DM00', 'ค่าบริการ ยังไม่ได้รับการจ่ายชดเชย-CHECK', 'EXCEPT-LGO2', '2020', '2021-06-16', '2021-09-30', '74', '75', 'LGO', 'บริการเฉพาะอื่นๆ', 'EXCEPT-DM00', 'ยกเว้นการจ่าย-บริการเฉพาะอื่นๆ', 'EXCEPT-UUC2-HMAIN', 'ต้นสังกัดรับผิดชอบค่าใช้จ่าย-ค่าบริการ ยังไม่ได้รับการจ่ายชดเชย-CHECK', 'AH', 'N');
INSERT IGNORE INTO `s_rep_project_eclaim_subfund` (`fund_type`, `fgcode`, `fcode`, `fundsub`, `subfund`, `gyear`, `start_date`, `end_date`, `deb_id_opd`, `deb_id_ipd`, `maininscl`, `fundmain`, `except_subfund`, `except_subfund_detail`, `hmain_subfund`, `hmain_subfund_detail`, `fgmain`, `extract_fund`) VALUES ('DM', 'DMIS', 'DM00', 'ค่าบริการ ยังไม่ได้รับการจ่ายชดเชย-CHECK', 'EXCEPT-OFC2', '2020', '2021-06-16', '2021-09-30', '13', '14', 'OFC', 'บริการเฉพาะอื่นๆ', 'EXCEPT-DM00', 'ยกเว้นการจ่าย-บริการเฉพาะอื่นๆ', 'EXCEPT-UUC2-HMAIN', 'ต้นสังกัดรับผิดชอบค่าใช้จ่าย-ค่าบริการ ยังไม่ได้รับการจ่ายชดเชย-CHECK', 'AH', 'N');
INSERT IGNORE INTO `s_rep_project_eclaim_subfund` (`fund_type`, `fgcode`, `fcode`, `fundsub`, `subfund`, `gyear`, `start_date`, `end_date`, `deb_id_opd`, `deb_id_ipd`, `maininscl`, `fundmain`, `except_subfund`, `except_subfund_detail`, `hmain_subfund`, `hmain_subfund_detail`, `fgmain`, `extract_fund`) VALUES ('DM', 'DMIS', 'DM00', 'ค่าบริการ ยังไม่ได้รับการจ่ายชดเชย-CHECK', 'EXCEPT-SSS2', '2020', '2021-06-16', '2021-09-30', '48', '66', 'SSS', 'บริการเฉพาะอื่นๆ', 'EXCEPT-DM00', 'ยกเว้นการจ่าย-บริการเฉพาะอื่นๆ', 'EXCEPT-UUC2-HMAIN', 'ต้นสังกัดรับผิดชอบค่าใช้จ่าย-ค่าบริการ ยังไม่ได้รับการจ่ายชดเชย-CHECK', 'AH', 'N');
 
  

-- ----------------------------
-- Procedure structure for sql0043_process_rep_eclaim_online_fund
-- ----------------------------
DROP PROCEDURE IF EXISTS `sql0043_process_rep_eclaim_online_fund`;
delimiter ;;
CREATE PROCEDURE `sql0043_process_rep_eclaim_online_fund`()
BEGIN



DECLARE chk TINYINT(0) DEFAULT 0; 
DECLARE tp VARCHAR(50);   
DECLARE mcl VARCHAR(10);   
DECLARE sql_var CURSOR FOR  SELECT DISTINCT
	a.tran_id ,a.maininscl
FROM
	`rep_eclaim_online` a 
LEFT JOIN rep_eclaim_online_fund b on  a.tran_id = b.tran_id
WHERE b.fund_main is null or b.fund_main='' or a.van_link<>b.van_link;
																											
DECLARE CONTINUE HANDLER FOR NOT FOUND SET chk = 1;
  
OPEN sql_var;
sql_command : LOOP
 
FETCH sql_var INTO tp,mcl ;

IF chk = 1 THEN
LEAVE sql_command;
END IF;
  
SET @sql_processO := CONCAT('/* "',tp,'" */REPLACE INTO rep_eclaim_online_fund (
tran_id,
van_link,
fund_main,
fund_sub,
pid,
hn,
hmain,
vstdate_www,
err_code,
va
)
SELECT 
	cc.tran_id,
	cc.van_link ,
	cc.fund_main,  
	cc.fund_sub ,
	cc.pid ,
	cc.hn,
	cc.hmain,
  cc.vstdate_www,
	cc.error_code,
  cc.va
	FROM(
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(a.fund_sub, ",", 1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 2), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
 
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 3), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 4), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 5), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
  
UNION ALL 
SELECT DISTINCT
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 6), ",", -1)
WHERE a.error_code="-" and a.tran_id="',tp,'"
GROUP BY a.tran_id  
) as cc
GROUP BY 
	cc.tran_id,
	cc.van_link ,
	cc.fund_main,  
	cc.fund_sub 
UNION ALL
SELECT 
	cc.tran_id,
	cc.van_link ,
	CASE 
	WHEN cc.maininscl ="LGO" and cc.oi="O" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="LGO" and cc.oi="I" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="SSS" and cc.oi="O" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="SSS" and cc.oi="I" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="OFC" and cc.oi="O" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="OFC" and cc.oi="I" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="UCS" and cc.oi="O" THEN "EXCEPT-UUC2"
	WHEN cc.maininscl ="UCS" and cc.oi="I" THEN "EXCEPT-UUC2"
	END as fund_main,  
		CASE 
	WHEN cc.maininscl ="LGO" and cc.oi="O" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="LGO" and cc.oi="I" THEN "EXCEPT-LGO2"
	WHEN cc.maininscl ="SSS" and cc.oi="O" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="SSS" and cc.oi="I" THEN "EXCEPT-SSS2"
	WHEN cc.maininscl ="OFC" and cc.oi="O" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="OFC" and cc.oi="I" THEN "EXCEPT-OFC2"
	WHEN cc.maininscl ="UCS" and cc.oi="O" THEN "EXCEPT-UUC2"
	WHEN cc.maininscl ="UCS" and cc.oi="I" THEN "EXCEPT-UUC2"
	END as  fund_sub ,
	cc.pid ,
	cc.hn,
	cc.hmain,
  cc.vstdate_www,
	cc.error_code,
  cc.va
	FROM(
SELECT DISTINCT
	a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(a.fund_sub, ",", 1)
WHERE (a.error_code!="-" or a.error_code!="") and a.tran_id="',tp,'"
GROUP BY a.tran_id
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 2), ",", -1)
WHERE (a.error_code!="-" or a.error_code!="") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
 
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 3), ",", -1)
WHERE (a.error_code!="-" or a.error_code!="") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 4), ",", -1)
WHERE (a.error_code!="-" or a.error_code!="") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 5), ",", -1)
WHERE (a.error_code!="-" or a.error_code!="") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
  
UNION ALL 
SELECT DISTINCT
a.maininscl,
	a.oi,
	a.tran_id,
	IFNULL(a.van_link,"-") as van_link ,
	b.fcode as fund_main,  
	b.subfund as fund_sub ,
	a.pid ,
	a.hn,
	a.hmain,
	a.vstdate_www,
	a.error_code,
	a.va
FROM
	`rep_eclaim_online` a
LEFT JOIN s_rep_project_eclaim_subfund b on b.subfund = SUBSTRING_INDEX(SUBSTRING_INDEX(a.fund_sub, ",", 6), ",", -1)
WHERE (a.error_code!="-" or a.error_code!="") and a.tran_id="',tp,'"
GROUP BY a.tran_id  
) as cc
GROUP BY 
	cc.tran_id,
	cc.van_link 
	
	');
 

 
     PREPARE `execO` FROM @sql_processO;
    EXECUTE `execO`;
		 
		
SET @sql_processU := CONCAT('/* "',tp,'" */UPDATE rep_eclaim_online_fund a
INNER JOIN 	`rep_eclaim_online` b on a.tran_id = b.tran_id 
SET a.maininscl=b.maininscl ,   a.oi=b.oi 
WHERE b.tran_id = "',tp,'" ');
 
      PREPARE `execU` FROM @sql_processU;
    EXECUTE `execU`;

		END LOOP sql_command;
CLOSE sql_var;

DELETE FROM rep_eclaim_online_fund WHERE fund_sub='';

 


END
;;
delimiter ;
 
 
 
INSERT IGNORE INTO  `sys_ehos_version` (`type`, `www_db_name`, `www_patch_from`, `www_patch_to`, `db_sql`, `version`, `date_version`, `detail`, `status`, `hos_program`, `dupdate`) VALUES ('sql_restore', 'Manual', 'http://www.ehosonline.com/center_eclaim_report_update/EHA/3LBKEG5WA2X7HMZ-sqlupdate_17032566RevB.tar', '/var/www/html/eha', '  ', 'V.DB.66.3.17 Rev.B', '660317145900', '<li>แก้ปัญหาแสดงข้อมูลยังแสดงผลรายงานเป็นรอเรียกเก็บ หลังจากนำเข้า Rep.แล้ว</li><li><a href=\'http://www.ehosonline.com/center_eclaim_report_update/EHA/3LBKEG5WA2X7HMZ-sqlupdate_17032566RevB.tar\'>**Download For Self Update**</a></li>', 'Y', 'Manual', '2023-03-17 15:09:56');